import Flutter
import UIKit

public class SwiftVideo360kalturaPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "video360kaltura", binaryMessenger: registrar.messenger())
    let instance = SwiftVideo360kalturaPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)

    let factory: FlutterPlatformViewFactory = PlayerFlutterViewFactory(binaryMessenger: registrar.messenger())
    let factoryId: String = "plugins.video_360_kaltura/player_view"
    registrar.register(factory, withId: factoryId)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "getPlatformVersion":
      getPlatformVersion(arguments: call.arguments, onResult: result)
    default:
      methodNotImplemented(arguments: call.arguments, onResult: result)
    }
  }
}

// MARK: FlutterMethodCalls
extension SwiftVideo360kalturaPlugin {
  private func getPlatformVersion(arguments: Any?, onResult: FlutterResult) {
    let platformVersion: String = "iOS \(UIDevice.current.systemVersion)"
    onResult(platformVersion)
  }

  private func methodNotImplemented(arguments: Any?, onResult: FlutterResult) {
    onResult(FlutterMethodNotImplemented)
  }
}
